searchData={"content_type":"text/markdown","items":[{"doc":"A Mix task that generates all Ecto migrations for your schema","ref":"Mix.Tasks.Sleeky.Migrations.html","title":"mix sleeky.migrations","type":"task"},{"doc":"A simple helper macro that sets up a bandit listener plugged to a router.\n\nUsage:\n\n```\ndefmodule MyApp.Endpoint do\n  use Sleeky.Endpoint,\n    otp_app: :my_app,\n    router: MyApp.Router\nend\n```\n\nAll options supported by Bandit can be provided via config, eg:\n\n```\nconfig :my_app, MyApp.Endpoint,\n  scheme: :http,\n  port: 8080\n```","ref":"Sleeky.Endpoint.html","title":"Sleeky.Endpoint","type":"module"},{"doc":"","ref":"Sleeky.Entity.html","title":"Sleeky.Entity","type":"module"},{"doc":"","ref":"Sleeky.Entity.html#action/2","title":"Sleeky.Entity.action/2","type":"function"},{"doc":"","ref":"Sleeky.Entity.html#add_to/3","title":"Sleeky.Entity.add_to/3","type":"function"},{"doc":"","ref":"Sleeky.Entity.html#entity/1","title":"Sleeky.Entity.entity/1","type":"function"},{"doc":"","ref":"Sleeky.Entity.html#field/2","title":"Sleeky.Entity.field/2","type":"function"},{"doc":"","ref":"Sleeky.Entity.html#field!/2","title":"Sleeky.Entity.field!/2","type":"function"},{"doc":"","ref":"Sleeky.Entity.html#fields!/2","title":"Sleeky.Entity.fields!/2","type":"function"},{"doc":"","ref":"Sleeky.Entity.html#new/1","title":"Sleeky.Entity.new/1","type":"function"},{"doc":"","ref":"Sleeky.Entity.Dsl.html","title":"Sleeky.Entity.Dsl","type":"module"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#action/2","title":"Sleeky.Entity.Dsl.action/2","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#attribute/3","title":"Sleeky.Entity.Dsl.attribute/3","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#belongs_to/2","title":"Sleeky.Entity.Dsl.belongs_to/2","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#has_many/2","title":"Sleeky.Entity.Dsl.has_many/2","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#immutable/0","title":"Sleeky.Entity.Dsl.immutable/0","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#key/2","title":"Sleeky.Entity.Dsl.key/2","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#slug/2","title":"Sleeky.Entity.Dsl.slug/2","type":"macro"},{"doc":"","ref":"Sleeky.Entity.Dsl.html#unique/2","title":"Sleeky.Entity.Dsl.unique/2","type":"macro"},{"doc":"Naive fuzzy search capabilities for entities","ref":"Sleeky.Entity.Ecto.FuzzySearch.html","title":"Sleeky.Entity.Ecto.FuzzySearch","type":"module"},{"doc":"","ref":"Sleeky.Entity.Ecto.FuzzySearch.html#ast/1","title":"Sleeky.Entity.Ecto.FuzzySearch.ast/1","type":"function"},{"doc":"","ref":"Sleeky.Entity.Relation.html","title":"Sleeky.Entity.Relation","type":"module"},{"doc":"","ref":"Sleeky.Entity.Relation.html#new/1","title":"Sleeky.Entity.Relation.new/1","type":"function"},{"doc":"","ref":"Sleeky.Entity.Relation.html#with_foreign_key/1","title":"Sleeky.Entity.Relation.with_foreign_key/1","type":"function"},{"doc":"","ref":"Sleeky.Entity.Relation.html#with_inverse/1","title":"Sleeky.Entity.Relation.with_inverse/1","type":"function"},{"doc":"","ref":"Sleeky.Entity.Relation.html#with_label/1","title":"Sleeky.Entity.Relation.with_label/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html","title":"Sleeky.Inspector","type":"module"},{"doc":"","ref":"Sleeky.Inspector.html#as_list/1","title":"Sleeky.Inspector.as_list/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#atoms/1","title":"Sleeky.Inspector.atoms/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#columns/1","title":"Sleeky.Inspector.columns/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#context/1","title":"Sleeky.Inspector.context/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#flatten/1","title":"Sleeky.Inspector.flatten/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#function_name/2","title":"Sleeky.Inspector.function_name/2","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#indexed/2","title":"Sleeky.Inspector.indexed/2","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#join/1","title":"Sleeky.Inspector.join/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#join/2","title":"Sleeky.Inspector.join/2","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#label/1","title":"Sleeky.Inspector.label/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#module/1","title":"Sleeky.Inspector.module/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#module/2","title":"Sleeky.Inspector.module/2","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#module_parts/1","title":"Sleeky.Inspector.module_parts/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#name/1","title":"Sleeky.Inspector.name/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#names/1","title":"Sleeky.Inspector.names/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#plural/1","title":"Sleeky.Inspector.plural/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#print/2","title":"Sleeky.Inspector.print/2","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#snake/1","title":"Sleeky.Inspector.snake/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#strings/1","title":"Sleeky.Inspector.strings/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#tokenize/2","title":"Sleeky.Inspector.tokenize/2","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#var/1","title":"Sleeky.Inspector.var/1","type":"function"},{"doc":"","ref":"Sleeky.Inspector.html#vars/1","title":"Sleeky.Inspector.vars/1","type":"function"},{"doc":"","ref":"Sleeky.Opts.html","title":"Sleeky.Opts","type":"module"},{"doc":"","ref":"Sleeky.Opts.html#with_opt/2","title":"Sleeky.Opts.with_opt/2","type":"function"},{"doc":"","ref":"Sleeky.Opts.html#with_opts/2","title":"Sleeky.Opts.with_opts/2","type":"function"},{"doc":"","ref":"Sleeky.Rest.html","title":"Sleeky.Rest","type":"module"},{"doc":"A macro that sets up a standard router, including default paths for ui, api and api docs","ref":"Sleeky.Router.html","title":"Sleeky.Router","type":"module"},{"doc":"","ref":"Sleeky.Schema.Dsl.html","title":"Sleeky.Schema.Dsl","type":"module"},{"doc":"","ref":"Sleeky.Schema.Dsl.html#entity/1","title":"Sleeky.Schema.Dsl.entity/1","type":"macro"},{"doc":"","ref":"Sleeky.Schema.Dsl.html#enum/1","title":"Sleeky.Schema.Dsl.enum/1","type":"macro"},{"doc":"Provides with the ability to create compound views.\n\nCompound views are simply views that depend on other views. This is useful in order to create layouts, eg:\n\n```elixir\ndefmodule MyApp.Ui.Layout do\n  use Sleeky.View\n\n  render do\n    html do\n      head do\n      end\n      body do\n        div class: \"main\" do\n          slot :main\n        end\n      end\n    end\n  end\nend\n```\n\nthen\n\n\n```elixir\ndefmodule MyApp.Ui.IndexPage do\n  use Sleeky.View\n\n  alias MyApp.Ui.Layout\n\n  render do\n    view Layout do\n      main do\n        h1 \"It works!\"\n      end\n    end\n  end\nend\n```\n\nIn the above example the layout view defines a slot named `:main`.\n\nThen the index page provides a value for that slot. The resolution phase, which happens at compile\n  time, is in charge of recursively going through all these dependencies and replacing slot\n  definitions by their values, until we obtain a new view definition that no longer has any\n  dependencies.","ref":"Sleeky.Ui.Compound.html","title":"Sleeky.Ui.Compound","type":"module"},{"doc":"Provides the support for resolving and transcluding view dependencies in a recursive manner","ref":"Sleeky.Ui.Compound.Resolve.html","title":"Sleeky.Ui.Compound.Resolve","type":"module"},{"doc":"Provides with basic Html support:\n\n* a DSL to define views with valid html markup, and translate into its internal definition\n* resolution and sanitization of internal definitions","ref":"Sleeky.Ui.Html.html","title":"Sleeky.Ui.Html","type":"module"},{"doc":"Renders a view's internal definition into Html.\n\nThe rendering phase happens once the view has been fully resolved","ref":"Sleeky.Ui.Render.html","title":"Sleeky.Ui.Render","type":"module"},{"doc":"Renders a view as html\n\nThe view is represented by its internal definition, which is a floki-like datastructure made of\nnested tuples","ref":"Sleeky.Ui.Render.html#to_html/1","title":"Sleeky.Ui.Render.to_html/1","type":"function"},{"doc":"This is the frontend module in charge of resolving a tree of views","ref":"Sleeky.Ui.Resolve.html","title":"Sleeky.Ui.Resolve","type":"module"},{"doc":"","ref":"Sleeky.Ui.Resolve.html#resolve/2","title":"Sleeky.Ui.Resolve.resolve/2","type":"function"},{"doc":"A Sleeky UI is made of Sleeky views.\n\nViews are expressed in pure Elixir, then compiled into an internal representation made of simple\n  tuples nested one within another, quite similar to what Floki does. Views can be expressed in\n  terms of other views. Resolving a view traverses all these dependencies and produces a final,\n  single internal representation that no longer depends on anything. Finally, once resolved, a\n  view gets rendered into plain html, in order to be served by a router. All this process happens\n  during compile time.\n\nUsage:\n\n```elixir\ndefmodule MyApp.Ui.SomeView do\n  use Sleeky.Ui.View\n\n  render do\n    html do\n      head do\n        title \"This is some nice title\"\n        meta charset: \"utf-8\"\n      end\n\n      body do\n        h1 class: \"title\" do\n          \"It works!\"\n        end\n      end\n    end\n  end\nend\n```","ref":"Sleeky.Ui.View.html","title":"Sleeky.Ui.View","type":"module"},{"doc":"","ref":"Sleeky.Ui.View.html#ast/2","title":"Sleeky.Ui.View.ast/2","type":"function"},{"doc":"","ref":"Sleeky.Ui.View.html#named/2","title":"Sleeky.Ui.View.named/2","type":"function"},{"doc":"","ref":"Sleeky.Ui.View.html#new/1","title":"Sleeky.Ui.View.new/1","type":"function"},{"doc":"","ref":"Sleeky.Ui.View.html#render/1","title":"Sleeky.Ui.View.render/1","type":"macro"}]}